-- MySQL dump 10.13  Distrib 5.5.31, for debian-linux-gnu (i686)
--
-- Host: localhost    Database: prueba
-- ------------------------------------------------------
-- Server version	5.5.31-0+wheezy1

/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8 */;
/*!40103 SET @OLD_TIME_ZONE=@@TIME_ZONE */;
/*!40103 SET TIME_ZONE='+00:00' */;
/*!40014 SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0 */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;
/*!40111 SET @OLD_SQL_NOTES=@@SQL_NOTES, SQL_NOTES=0 */;

--
-- Table structure for table `article`
--

DROP TABLE IF EXISTS `article`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `article` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `type` tinyint(4) DEFAULT NULL,
  `name` varchar(256) NOT NULL,
  `title` varchar(256) NOT NULL,
  `heading` varchar(512) DEFAULT NULL,
  `comment` text,
  `description` text,
  `upper_description` varchar(256) DEFAULT NULL,
  `body` text NOT NULL,
  `created_at` datetime DEFAULT NULL,
  `updated_at` datetime DEFAULT NULL,
  `created_by` int(11) DEFAULT NULL,
  `updated_by` int(11) DEFAULT NULL,
  `is_published` int(11) DEFAULT NULL,
  `is_archived` int(11) DEFAULT NULL,
  `published_at` datetime DEFAULT NULL,
  `archived_at` datetime DEFAULT NULL,
  `signature` text,
  `contact` varchar(256) DEFAULT NULL,
  `zoomable_multimedia` int(11) DEFAULT NULL,
  `multimedia_id` int(11) DEFAULT NULL,
  `main_gallery_id` int(11) DEFAULT NULL,
  `link_id` int(11) DEFAULT NULL,
  `source_id` int(11) DEFAULT NULL,
  `section_id` int(11) DEFAULT NULL,
  `reference` varchar(255) DEFAULT NULL,
  `reference_type` tinyint(4) DEFAULT '0',
  `times_read` bigint(20) DEFAULT NULL,
  `rating` decimal(10,0) DEFAULT NULL,
  `open_as_popup` int(11) DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `name_publmished_at_index` (`name`,`published_at`),
  KEY `article_FI_1` (`created_by`),
  KEY `article_FI_2` (`updated_by`),
  KEY `article_FI_3` (`multimedia_id`),
  KEY `article_FI_4` (`main_gallery_id`),
  KEY `article_FI_5` (`link_id`),
  KEY `article_FI_6` (`source_id`),
  KEY `article_FI_7` (`section_id`),
  CONSTRAINT `article_FK_1` FOREIGN KEY (`created_by`) REFERENCES `sf_guard_user` (`id`),
  CONSTRAINT `article_FK_2` FOREIGN KEY (`updated_by`) REFERENCES `sf_guard_user` (`id`),
  CONSTRAINT `article_FK_3` FOREIGN KEY (`multimedia_id`) REFERENCES `multimedia` (`id`) ON DELETE SET NULL,
  CONSTRAINT `article_FK_4` FOREIGN KEY (`main_gallery_id`) REFERENCES `gallery` (`id`) ON DELETE SET NULL,
  CONSTRAINT `article_FK_5` FOREIGN KEY (`link_id`) REFERENCES `link` (`id`) ON DELETE SET NULL,
  CONSTRAINT `article_FK_6` FOREIGN KEY (`source_id`) REFERENCES `source` (`id`) ON DELETE SET NULL,
  CONSTRAINT `article_FK_7` FOREIGN KEY (`section_id`) REFERENCES `section` (`id`) ON DELETE SET NULL
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `article`
--

LOCK TABLES `article` WRITE;
/*!40000 ALTER TABLE `article` DISABLE KEYS */;
/*!40000 ALTER TABLE `article` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `article_article`
--

DROP TABLE IF EXISTS `article_article`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `article_article` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `article_referer_id` int(11) DEFAULT NULL,
  `article_referee_id` int(11) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `article_article_FI_1` (`article_referer_id`),
  KEY `article_article_FI_2` (`article_referee_id`),
  CONSTRAINT `article_article_FK_1` FOREIGN KEY (`article_referer_id`) REFERENCES `article` (`id`) ON DELETE CASCADE,
  CONSTRAINT `article_article_FK_2` FOREIGN KEY (`article_referee_id`) REFERENCES `article` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `article_article`
--

LOCK TABLES `article_article` WRITE;
/*!40000 ALTER TABLE `article_article` DISABLE KEYS */;
/*!40000 ALTER TABLE `article_article` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `article_article_group`
--

DROP TABLE IF EXISTS `article_article_group`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `article_article_group` (
  `article_id` int(11) DEFAULT NULL,
  `article_group_id` int(11) DEFAULT NULL,
  `priority` int(11) DEFAULT '0',
  `id` int(11) NOT NULL AUTO_INCREMENT,
  PRIMARY KEY (`id`),
  KEY `article_article_group_FI_1` (`article_id`),
  KEY `article_article_group_FI_2` (`article_group_id`),
  CONSTRAINT `article_article_group_FK_1` FOREIGN KEY (`article_id`) REFERENCES `article` (`id`) ON DELETE CASCADE,
  CONSTRAINT `article_article_group_FK_2` FOREIGN KEY (`article_group_id`) REFERENCES `article_group` (`id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `article_article_group`
--

LOCK TABLES `article_article_group` WRITE;
/*!40000 ALTER TABLE `article_article_group` DISABLE KEYS */;
/*!40000 ALTER TABLE `article_article_group` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `article_document`
--

DROP TABLE IF EXISTS `article_document`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `article_document` (
  `article_id` int(11) DEFAULT NULL,
  `document_id` int(11) DEFAULT NULL,
  `id` int(11) NOT NULL AUTO_INCREMENT,
  PRIMARY KEY (`id`),
  KEY `article_document_FI_1` (`article_id`),
  KEY `article_document_FI_2` (`document_id`),
  CONSTRAINT `article_document_FK_1` FOREIGN KEY (`article_id`) REFERENCES `article` (`id`) ON DELETE CASCADE,
  CONSTRAINT `article_document_FK_2` FOREIGN KEY (`document_id`) REFERENCES `document` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `article_document`
--

LOCK TABLES `article_document` WRITE;
/*!40000 ALTER TABLE `article_document` DISABLE KEYS */;
/*!40000 ALTER TABLE `article_document` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `article_form`
--

DROP TABLE IF EXISTS `article_form`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `article_form` (
  `article_id` int(11) DEFAULT NULL,
  `form_id` int(11) DEFAULT NULL,
  `id` int(11) NOT NULL AUTO_INCREMENT,
  PRIMARY KEY (`id`),
  KEY `article_form_FI_1` (`article_id`),
  KEY `article_form_FI_2` (`form_id`),
  CONSTRAINT `article_form_FK_1` FOREIGN KEY (`article_id`) REFERENCES `article` (`id`) ON DELETE CASCADE,
  CONSTRAINT `article_form_FK_2` FOREIGN KEY (`form_id`) REFERENCES `form` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `article_form`
--

LOCK TABLES `article_form` WRITE;
/*!40000 ALTER TABLE `article_form` DISABLE KEYS */;
/*!40000 ALTER TABLE `article_form` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `article_gallery`
--

DROP TABLE IF EXISTS `article_gallery`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `article_gallery` (
  `article_id` int(11) DEFAULT NULL,
  `gallery_id` int(11) DEFAULT NULL,
  `id` int(11) NOT NULL AUTO_INCREMENT,
  PRIMARY KEY (`id`),
  KEY `article_gallery_FI_1` (`article_id`),
  KEY `article_gallery_FI_2` (`gallery_id`),
  CONSTRAINT `article_gallery_FK_1` FOREIGN KEY (`article_id`) REFERENCES `article` (`id`) ON DELETE CASCADE,
  CONSTRAINT `article_gallery_FK_2` FOREIGN KEY (`gallery_id`) REFERENCES `gallery` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `article_gallery`
--

LOCK TABLES `article_gallery` WRITE;
/*!40000 ALTER TABLE `article_gallery` DISABLE KEYS */;
/*!40000 ALTER TABLE `article_gallery` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `article_group`
--

DROP TABLE IF EXISTS `article_group`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `article_group` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(256) NOT NULL,
  `description` text,
  `comment` text,
  `visible_items` tinyint(4) DEFAULT '0',
  `is_published` int(11) DEFAULT NULL,
  `created_at` datetime DEFAULT NULL,
  `published_at` datetime DEFAULT NULL,
  `created_by` int(11) DEFAULT NULL,
  `updated_at` datetime DEFAULT NULL,
  `updated_by` int(11) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `article_group_FI_1` (`created_by`),
  KEY `article_group_FI_2` (`updated_by`),
  CONSTRAINT `article_group_FK_1` FOREIGN KEY (`created_by`) REFERENCES `sf_guard_user` (`id`) ON DELETE SET NULL,
  CONSTRAINT `article_group_FK_2` FOREIGN KEY (`updated_by`) REFERENCES `sf_guard_user` (`id`) ON DELETE SET NULL
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `article_group`
--

LOCK TABLES `article_group` WRITE;
/*!40000 ALTER TABLE `article_group` DISABLE KEYS */;
/*!40000 ALTER TABLE `article_group` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `article_link_group`
--

DROP TABLE IF EXISTS `article_link_group`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `article_link_group` (
  `article_id` int(11) DEFAULT NULL,
  `link_group_id` int(11) DEFAULT NULL,
  `id` int(11) NOT NULL AUTO_INCREMENT,
  PRIMARY KEY (`id`),
  KEY `article_link_group_FI_1` (`article_id`),
  KEY `article_link_group_FI_2` (`link_group_id`),
  CONSTRAINT `article_link_group_FK_1` FOREIGN KEY (`article_id`) REFERENCES `article` (`id`) ON DELETE CASCADE,
  CONSTRAINT `article_link_group_FK_2` FOREIGN KEY (`link_group_id`) REFERENCES `link_group` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `article_link_group`
--

LOCK TABLES `article_link_group` WRITE;
/*!40000 ALTER TABLE `article_link_group` DISABLE KEYS */;
/*!40000 ALTER TABLE `article_link_group` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `article_multimedia`
--

DROP TABLE IF EXISTS `article_multimedia`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `article_multimedia` (
  `article_id` int(11) DEFAULT NULL,
  `multimedia_id` int(11) DEFAULT NULL,
  `id` int(11) NOT NULL AUTO_INCREMENT,
  PRIMARY KEY (`id`),
  KEY `article_multimedia_FI_1` (`article_id`),
  KEY `article_multimedia_FI_2` (`multimedia_id`),
  CONSTRAINT `article_multimedia_FK_1` FOREIGN KEY (`article_id`) REFERENCES `article` (`id`) ON DELETE CASCADE,
  CONSTRAINT `article_multimedia_FK_2` FOREIGN KEY (`multimedia_id`) REFERENCES `multimedia` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `article_multimedia`
--

LOCK TABLES `article_multimedia` WRITE;
/*!40000 ALTER TABLE `article_multimedia` DISABLE KEYS */;
/*!40000 ALTER TABLE `article_multimedia` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `article_rss_channel`
--

DROP TABLE IF EXISTS `article_rss_channel`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `article_rss_channel` (
  `article_id` int(11) DEFAULT NULL,
  `rss_channel_id` int(11) DEFAULT NULL,
  `id` int(11) NOT NULL AUTO_INCREMENT,
  PRIMARY KEY (`id`),
  KEY `article_rss_channel_FI_1` (`article_id`),
  KEY `article_rss_channel_FI_2` (`rss_channel_id`),
  CONSTRAINT `article_rss_channel_FK_1` FOREIGN KEY (`article_id`) REFERENCES `article` (`id`) ON DELETE CASCADE,
  CONSTRAINT `article_rss_channel_FK_2` FOREIGN KEY (`rss_channel_id`) REFERENCES `rss_channel` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `article_rss_channel`
--

LOCK TABLES `article_rss_channel` WRITE;
/*!40000 ALTER TABLE `article_rss_channel` DISABLE KEYS */;
/*!40000 ALTER TABLE `article_rss_channel` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `article_section`
--

DROP TABLE IF EXISTS `article_section`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `article_section` (
  `article_id` int(11) DEFAULT NULL,
  `section_id` int(11) DEFAULT NULL,
  `priority` int(11) DEFAULT '0',
  `id` int(11) NOT NULL AUTO_INCREMENT,
  PRIMARY KEY (`id`),
  KEY `article_section_FI_1` (`article_id`),
  KEY `article_section_FI_2` (`section_id`),
  CONSTRAINT `article_section_FK_1` FOREIGN KEY (`article_id`) REFERENCES `article` (`id`) ON DELETE CASCADE,
  CONSTRAINT `article_section_FK_2` FOREIGN KEY (`section_id`) REFERENCES `section` (`id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `article_section`
--

LOCK TABLES `article_section` WRITE;
/*!40000 ALTER TABLE `article_section` DISABLE KEYS */;
/*!40000 ALTER TABLE `article_section` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `article_tag`
--

DROP TABLE IF EXISTS `article_tag`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `article_tag` (
  `article_id` int(11) DEFAULT NULL,
  `tag_id` int(11) DEFAULT NULL,
  `id` int(11) NOT NULL AUTO_INCREMENT,
  PRIMARY KEY (`id`),
  KEY `article_tag_FI_1` (`article_id`),
  KEY `article_tag_FI_2` (`tag_id`),
  CONSTRAINT `article_tag_FK_1` FOREIGN KEY (`article_id`) REFERENCES `article` (`id`) ON DELETE CASCADE,
  CONSTRAINT `article_tag_FK_2` FOREIGN KEY (`tag_id`) REFERENCES `tag` (`id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `article_tag`
--

LOCK TABLES `article_tag` WRITE;
/*!40000 ALTER TABLE `article_tag` DISABLE KEYS */;
/*!40000 ALTER TABLE `article_tag` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `cms_configuration`
--

DROP TABLE IF EXISTS `cms_configuration`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `cms_configuration` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) DEFAULT NULL,
  `configuration_key` varchar(255) NOT NULL,
  `configuration_value` text,
  PRIMARY KEY (`id`),
  KEY `configuration_key_index` (`configuration_key`)
) ENGINE=InnoDB AUTO_INCREMENT=8 DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `cms_configuration`
--

LOCK TABLES `cms_configuration` WRITE;
/*!40000 ALTER TABLE `cms_configuration` DISABLE KEYS */;
INSERT INTO `cms_configuration` VALUES (1,'SecciÃ³n \'Inicio\' (HOME del sitio)','custom_section_home','1'),(2,'InformaciÃ³n para buscadores','site_metas','CMS'),(3,'Mostrar vÃ­nculo todas las noticias en el inicio','check_show_show_all','1'),(4,'Utilizar distribuciones por secciÃ³n','check_use_layout_per_section','0'),(5,'Utilizar fuentes periodÃ­sticas','check_use_sources','1'),(6,'Permitir utilizar artÃ­culos como pop up','check_allow_article_popup','1'),(7,'Utilizar categorÃ­as','check_use_tags','1');
/*!40000 ALTER TABLE `cms_configuration` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `container`
--

DROP TABLE IF EXISTS `container`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `container` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(256) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `container`
--

LOCK TABLES `container` WRITE;
/*!40000 ALTER TABLE `container` DISABLE KEYS */;
/*!40000 ALTER TABLE `container` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `container_slotlet`
--

DROP TABLE IF EXISTS `container_slotlet`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `container_slotlet` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `container_id` int(11) DEFAULT NULL,
  `slotlet_id` int(11) DEFAULT NULL,
  `name` varchar(256) NOT NULL,
  `priority` int(11) DEFAULT '0',
  `rss_channel_id` int(11) DEFAULT NULL,
  `visible_rss` int(11) DEFAULT '3',
  PRIMARY KEY (`id`),
  KEY `container_slotlet_FI_1` (`container_id`),
  KEY `container_slotlet_FI_2` (`slotlet_id`),
  KEY `container_slotlet_FI_3` (`rss_channel_id`),
  CONSTRAINT `container_slotlet_FK_1` FOREIGN KEY (`container_id`) REFERENCES `container` (`id`) ON DELETE CASCADE,
  CONSTRAINT `container_slotlet_FK_2` FOREIGN KEY (`slotlet_id`) REFERENCES `slotlet` (`id`),
  CONSTRAINT `container_slotlet_FK_3` FOREIGN KEY (`rss_channel_id`) REFERENCES `rss_channel` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `container_slotlet`
--

LOCK TABLES `container_slotlet` WRITE;
/*!40000 ALTER TABLE `container_slotlet` DISABLE KEYS */;
/*!40000 ALTER TABLE `container_slotlet` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `data`
--

DROP TABLE IF EXISTS `data`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `data` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `row` int(11) DEFAULT NULL,
  `data` text,
  `field_id` int(11) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `data_FI_1` (`field_id`),
  CONSTRAINT `data_FK_1` FOREIGN KEY (`field_id`) REFERENCES `field` (`id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `data`
--

LOCK TABLES `data` WRITE;
/*!40000 ALTER TABLE `data` DISABLE KEYS */;
/*!40000 ALTER TABLE `data` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `document`
--

DROP TABLE IF EXISTS `document`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `document` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(256) NOT NULL,
  `title` varchar(256) NOT NULL,
  `uri` varchar(256) NOT NULL,
  `uploaded_by` int(11) DEFAULT NULL,
  `created_at` datetime DEFAULT NULL,
  `updated_at` datetime DEFAULT NULL,
  `updated_by` int(11) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `document_FI_1` (`uploaded_by`),
  KEY `document_FI_2` (`updated_by`),
  CONSTRAINT `document_FK_1` FOREIGN KEY (`uploaded_by`) REFERENCES `sf_guard_user` (`id`) ON DELETE SET NULL,
  CONSTRAINT `document_FK_2` FOREIGN KEY (`updated_by`) REFERENCES `sf_guard_user` (`id`) ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `document`
--

LOCK TABLES `document` WRITE;
/*!40000 ALTER TABLE `document` DISABLE KEYS */;
/*!40000 ALTER TABLE `document` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `event`
--

DROP TABLE IF EXISTS `event`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `event` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `is_published` int(11) DEFAULT NULL,
  `title` varchar(256) NOT NULL,
  `description` text,
  `location` varchar(256) DEFAULT NULL,
  `contact` varchar(256) DEFAULT NULL,
  `organizer` varchar(256) DEFAULT NULL,
  `author` int(11) DEFAULT NULL,
  `comment` text,
  `begins_at` datetime DEFAULT NULL,
  `ends_at` datetime DEFAULT NULL,
  `article_id` int(11) DEFAULT NULL,
  `event_type_id` int(11) DEFAULT NULL,
  `created_at` datetime DEFAULT NULL,
  `updated_by` int(11) DEFAULT NULL,
  `updated_at` datetime DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `event_FI_1` (`author`),
  KEY `event_FI_2` (`article_id`),
  KEY `event_FI_3` (`event_type_id`),
  KEY `event_FI_4` (`updated_by`),
  CONSTRAINT `event_FK_1` FOREIGN KEY (`author`) REFERENCES `sf_guard_user` (`id`),
  CONSTRAINT `event_FK_2` FOREIGN KEY (`article_id`) REFERENCES `article` (`id`),
  CONSTRAINT `event_FK_3` FOREIGN KEY (`event_type_id`) REFERENCES `event_type` (`id`) ON DELETE SET NULL,
  CONSTRAINT `event_FK_4` FOREIGN KEY (`updated_by`) REFERENCES `sf_guard_user` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `event`
--

LOCK TABLES `event` WRITE;
/*!40000 ALTER TABLE `event` DISABLE KEYS */;
/*!40000 ALTER TABLE `event` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `event_section`
--

DROP TABLE IF EXISTS `event_section`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `event_section` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `event_id` int(11) NOT NULL,
  `section_id` int(11) NOT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `unique_event_section` (`event_id`,`section_id`),
  KEY `event_section_FI_2` (`section_id`),
  CONSTRAINT `event_section_FK_1` FOREIGN KEY (`event_id`) REFERENCES `event` (`id`) ON DELETE CASCADE,
  CONSTRAINT `event_section_FK_2` FOREIGN KEY (`section_id`) REFERENCES `section` (`id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `event_section`
--

LOCK TABLES `event_section` WRITE;
/*!40000 ALTER TABLE `event_section` DISABLE KEYS */;
/*!40000 ALTER TABLE `event_section` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `event_type`
--

DROP TABLE IF EXISTS `event_type`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `event_type` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `title` varchar(256) NOT NULL,
  `description` text,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `event_type`
--

LOCK TABLES `event_type` WRITE;
/*!40000 ALTER TABLE `event_type` DISABLE KEYS */;
/*!40000 ALTER TABLE `event_type` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field`
--

DROP TABLE IF EXISTS `field`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `label` varchar(256) DEFAULT NULL,
  `type` int(11) DEFAULT NULL,
  `is_required` int(11) DEFAULT NULL,
  `default_value` text,
  `sort` int(11) DEFAULT NULL,
  `form_id` int(11) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `field_FI_1` (`form_id`),
  CONSTRAINT `field_FK_1` FOREIGN KEY (`form_id`) REFERENCES `form` (`id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field`
--

LOCK TABLES `field` WRITE;
/*!40000 ALTER TABLE `field` DISABLE KEYS */;
/*!40000 ALTER TABLE `field` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `form`
--

DROP TABLE IF EXISTS `form`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `form` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `title` varchar(256) NOT NULL,
  `name` varchar(256) DEFAULT NULL,
  `description` text,
  `comment` text,
  `rows` int(11) DEFAULT NULL,
  `is_poll` int(11) DEFAULT NULL,
  `is_active` int(11) DEFAULT NULL,
  `success_msg` varchar(256) DEFAULT NULL,
  `email` varchar(255) DEFAULT NULL,
  `created_at` datetime DEFAULT NULL,
  `updated_at` datetime DEFAULT NULL,
  `created_by` int(11) DEFAULT NULL,
  `updated_by` int(11) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `form_FI_1` (`created_by`),
  KEY `form_FI_2` (`updated_by`),
  CONSTRAINT `form_FK_1` FOREIGN KEY (`created_by`) REFERENCES `sf_guard_user` (`id`) ON UPDATE CASCADE,
  CONSTRAINT `form_FK_2` FOREIGN KEY (`updated_by`) REFERENCES `sf_guard_user` (`id`) ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `form`
--

LOCK TABLES `form` WRITE;
/*!40000 ALTER TABLE `form` DISABLE KEYS */;
/*!40000 ALTER TABLE `form` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `gallery`
--

DROP TABLE IF EXISTS `gallery`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `gallery` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(256) NOT NULL,
  `description` text,
  `comment` text,
  `is_horizontal` int(11) DEFAULT '1',
  `visible_items` tinyint(4) DEFAULT '0',
  `is_published` int(11) DEFAULT NULL,
  `created_at` datetime DEFAULT NULL,
  `published_at` datetime DEFAULT NULL,
  `created_by` int(11) DEFAULT NULL,
  `updated_at` datetime DEFAULT NULL,
  `updated_by` int(11) DEFAULT NULL,
  `published_by` int(11) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `gallery_FI_1` (`created_by`),
  KEY `gallery_FI_2` (`updated_by`),
  KEY `gallery_FI_3` (`published_by`),
  CONSTRAINT `gallery_FK_1` FOREIGN KEY (`created_by`) REFERENCES `sf_guard_user` (`id`) ON DELETE SET NULL,
  CONSTRAINT `gallery_FK_2` FOREIGN KEY (`updated_by`) REFERENCES `sf_guard_user` (`id`) ON DELETE SET NULL,
  CONSTRAINT `gallery_FK_3` FOREIGN KEY (`published_by`) REFERENCES `sf_guard_user` (`id`) ON DELETE SET NULL
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `gallery`
--

LOCK TABLES `gallery` WRITE;
/*!40000 ALTER TABLE `gallery` DISABLE KEYS */;
/*!40000 ALTER TABLE `gallery` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `layout`
--

DROP TABLE IF EXISTS `layout`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `layout` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) NOT NULL,
  `article_layout` text,
  `template_layout` text,
  `is_default` int(11) DEFAULT '0',
  `virtual_section_id` int(11) DEFAULT NULL,
  `created_at` datetime DEFAULT NULL,
  `updated_at` datetime DEFAULT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `layout_name_unique` (`name`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `layout`
--

LOCK TABLES `layout` WRITE;
/*!40000 ALTER TABLE `layout` DISABLE KEYS */;
/*!40000 ALTER TABLE `layout` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `link`
--

DROP TABLE IF EXISTS `link`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `link` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(256) DEFAULT NULL,
  `uri` varchar(256) DEFAULT NULL,
  `url` varchar(256) DEFAULT NULL,
  `created_by` int(11) DEFAULT NULL,
  `created_at` datetime DEFAULT NULL,
  `updated_by` int(11) DEFAULT NULL,
  `updated_at` datetime DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `link_FI_1` (`created_by`),
  KEY `link_FI_2` (`updated_by`),
  CONSTRAINT `link_FK_1` FOREIGN KEY (`created_by`) REFERENCES `sf_guard_user` (`id`),
  CONSTRAINT `link_FK_2` FOREIGN KEY (`updated_by`) REFERENCES `sf_guard_user` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `link`
--

LOCK TABLES `link` WRITE;
/*!40000 ALTER TABLE `link` DISABLE KEYS */;
/*!40000 ALTER TABLE `link` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `link_group`
--

DROP TABLE IF EXISTS `link_group`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `link_group` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(256) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `link_group`
--

LOCK TABLES `link_group` WRITE;
/*!40000 ALTER TABLE `link_group` DISABLE KEYS */;
/*!40000 ALTER TABLE `link_group` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `link_group_link`
--

DROP TABLE IF EXISTS `link_group_link`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `link_group_link` (
  `link_group_id` int(11) DEFAULT NULL,
  `link_id` int(11) DEFAULT NULL,
  `id` int(11) NOT NULL AUTO_INCREMENT,
  PRIMARY KEY (`id`),
  KEY `link_group_link_FI_1` (`link_group_id`),
  KEY `link_group_link_FI_2` (`link_id`),
  CONSTRAINT `link_group_link_FK_1` FOREIGN KEY (`link_group_id`) REFERENCES `link_group` (`id`) ON DELETE CASCADE,
  CONSTRAINT `link_group_link_FK_2` FOREIGN KEY (`link_id`) REFERENCES `link` (`id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `link_group_link`
--

LOCK TABLES `link_group_link` WRITE;
/*!40000 ALTER TABLE `link_group_link` DISABLE KEYS */;
/*!40000 ALTER TABLE `link_group_link` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `mail_log`
--

DROP TABLE IF EXISTS `mail_log`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `mail_log` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `mail_from` varchar(255) NOT NULL,
  `mail_to` varchar(255) NOT NULL,
  `subject` varchar(255) NOT NULL,
  `body` text NOT NULL,
  `sender_name` varchar(255) NOT NULL,
  `section_name` varchar(255) DEFAULT NULL,
  `article_name` varchar(255) DEFAULT NULL,
  `created_at` datetime DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `mail_log`
--

LOCK TABLES `mail_log` WRITE;
/*!40000 ALTER TABLE `mail_log` DISABLE KEYS */;
/*!40000 ALTER TABLE `mail_log` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `multimedia`
--

DROP TABLE IF EXISTS `multimedia`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `multimedia` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(256) NOT NULL,
  `title` varchar(256) NOT NULL,
  `description` text,
  `comment` text,
  `is_deleted` int(11) DEFAULT NULL,
  `small_uri` varchar(256) DEFAULT NULL,
  `medium_uri` varchar(256) DEFAULT NULL,
  `large_uri` varchar(256) NOT NULL,
  `author` varchar(256) DEFAULT NULL,
  `uploaded_by` int(11) DEFAULT NULL,
  `copyright` varchar(256) DEFAULT NULL,
  `type` varchar(20) DEFAULT NULL,
  `language` varchar(5) DEFAULT NULL,
  `duration` tinyint(4) DEFAULT NULL,
  `location` varchar(256) DEFAULT NULL,
  `subject` varchar(256) DEFAULT NULL,
  `topics` varchar(256) DEFAULT NULL,
  `height` bigint(20) DEFAULT NULL,
  `width` bigint(20) DEFAULT NULL,
  `mime_type` varchar(256) NOT NULL,
  `created_at` datetime DEFAULT NULL,
  `flv_params` text,
  `is_external` int(11) DEFAULT '0',
  `player_id` int(11) DEFAULT NULL,
  `external_uri` text,
  `times_seen` int(11) DEFAULT NULL,
  `rating` decimal(10,0) DEFAULT NULL,
  `times_rated` int(11) DEFAULT NULL,
  `times_downloaded` int(11) DEFAULT NULL,
  `longdesc_uri` varchar(256) DEFAULT NULL,
  `updated_at` datetime DEFAULT NULL,
  `updated_by` int(11) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `multimedia_FI_1` (`uploaded_by`),
  KEY `multimedia_FI_2` (`updated_by`),
  CONSTRAINT `multimedia_FK_1` FOREIGN KEY (`uploaded_by`) REFERENCES `sf_guard_user` (`id`) ON DELETE SET NULL,
  CONSTRAINT `multimedia_FK_2` FOREIGN KEY (`updated_by`) REFERENCES `sf_guard_user` (`id`) ON DELETE SET NULL
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `multimedia`
--

LOCK TABLES `multimedia` WRITE;
/*!40000 ALTER TABLE `multimedia` DISABLE KEYS */;
/*!40000 ALTER TABLE `multimedia` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `multimedia_gallery`
--

DROP TABLE IF EXISTS `multimedia_gallery`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `multimedia_gallery` (
  `multimedia_id` int(11) DEFAULT NULL,
  `gallery_id` int(11) DEFAULT NULL,
  `priority` int(11) DEFAULT '0',
  `id` int(11) NOT NULL AUTO_INCREMENT,
  PRIMARY KEY (`id`),
  KEY `multimedia_gallery_FI_1` (`multimedia_id`),
  KEY `multimedia_gallery_FI_2` (`gallery_id`),
  CONSTRAINT `multimedia_gallery_FK_1` FOREIGN KEY (`multimedia_id`) REFERENCES `multimedia` (`id`) ON DELETE CASCADE,
  CONSTRAINT `multimedia_gallery_FK_2` FOREIGN KEY (`gallery_id`) REFERENCES `gallery` (`id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `multimedia_gallery`
--

LOCK TABLES `multimedia_gallery` WRITE;
/*!40000 ALTER TABLE `multimedia_gallery` DISABLE KEYS */;
/*!40000 ALTER TABLE `multimedia_gallery` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `multimedia_tag`
--

DROP TABLE IF EXISTS `multimedia_tag`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `multimedia_tag` (
  `multimedia_id` int(11) DEFAULT NULL,
  `tag_id` int(11) DEFAULT NULL,
  `id` int(11) NOT NULL AUTO_INCREMENT,
  PRIMARY KEY (`id`),
  KEY `multimedia_tag_FI_1` (`multimedia_id`),
  KEY `multimedia_tag_FI_2` (`tag_id`),
  CONSTRAINT `multimedia_tag_FK_1` FOREIGN KEY (`multimedia_id`) REFERENCES `multimedia` (`id`) ON DELETE CASCADE,
  CONSTRAINT `multimedia_tag_FK_2` FOREIGN KEY (`tag_id`) REFERENCES `tag` (`id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `multimedia_tag`
--

LOCK TABLES `multimedia_tag` WRITE;
/*!40000 ALTER TABLE `multimedia_tag` DISABLE KEYS */;
/*!40000 ALTER TABLE `multimedia_tag` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `news_space`
--

DROP TABLE IF EXISTS `news_space`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `news_space` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `type` tinyint(4) DEFAULT NULL,
  `comment` text,
  `row_number` tinyint(4) DEFAULT NULL,
  `column_number` tinyint(4) DEFAULT NULL,
  `template_id` int(11) DEFAULT NULL,
  `article_id` int(11) DEFAULT NULL,
  `width` float DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `news_space_FI_1` (`template_id`),
  KEY `news_space_FI_2` (`article_id`),
  CONSTRAINT `news_space_FK_1` FOREIGN KEY (`template_id`) REFERENCES `template` (`id`) ON DELETE CASCADE,
  CONSTRAINT `news_space_FK_2` FOREIGN KEY (`article_id`) REFERENCES `article` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `news_space`
--

LOCK TABLES `news_space` WRITE;
/*!40000 ALTER TABLE `news_space` DISABLE KEYS */;
/*!40000 ALTER TABLE `news_space` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `rss_channel`
--

DROP TABLE IF EXISTS `rss_channel`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `rss_channel` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `title` varchar(255) NOT NULL,
  `link` varchar(255) NOT NULL,
  `is_active` int(11) NOT NULL,
  `created_at` datetime DEFAULT NULL,
  `updated_at` datetime DEFAULT NULL,
  `created_by` int(11) DEFAULT NULL,
  `updated_by` int(11) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `rss_channel_FI_1` (`created_by`),
  KEY `rss_channel_FI_2` (`updated_by`),
  CONSTRAINT `rss_channel_FK_1` FOREIGN KEY (`created_by`) REFERENCES `sf_guard_user` (`id`),
  CONSTRAINT `rss_channel_FK_2` FOREIGN KEY (`updated_by`) REFERENCES `sf_guard_user` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `rss_channel`
--

LOCK TABLES `rss_channel` WRITE;
/*!40000 ALTER TABLE `rss_channel` DISABLE KEYS */;
/*!40000 ALTER TABLE `rss_channel` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `section`
--

DROP TABLE IF EXISTS `section`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `section` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(256) NOT NULL,
  `title` text NOT NULL,
  `priority` int(11) DEFAULT '0',
  `description` text,
  `comment` text,
  `is_published` int(11) DEFAULT '0',
  `multimedia_id` int(11) DEFAULT NULL,
  `section_id` int(11) DEFAULT NULL,
  `template_id` int(11) DEFAULT NULL,
  `article_id` int(11) DEFAULT NULL,
  `layout_id` int(11) DEFAULT NULL,
  `color` varchar(7) DEFAULT NULL,
  `article_group_id` int(11) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `name_index` (`name`),
  KEY `section_FI_1` (`multimedia_id`),
  KEY `section_FI_2` (`section_id`),
  KEY `section_FI_3` (`template_id`),
  KEY `section_FI_4` (`article_id`),
  KEY `section_FI_5` (`layout_id`),
  KEY `section_FI_6` (`article_group_id`),
  CONSTRAINT `section_FK_1` FOREIGN KEY (`multimedia_id`) REFERENCES `multimedia` (`id`) ON DELETE SET NULL,
  CONSTRAINT `section_FK_2` FOREIGN KEY (`section_id`) REFERENCES `section` (`id`),
  CONSTRAINT `section_FK_3` FOREIGN KEY (`template_id`) REFERENCES `template` (`id`) ON DELETE SET NULL,
  CONSTRAINT `section_FK_4` FOREIGN KEY (`article_id`) REFERENCES `article` (`id`),
  CONSTRAINT `section_FK_5` FOREIGN KEY (`layout_id`) REFERENCES `layout` (`id`) ON DELETE SET NULL,
  CONSTRAINT `section_FK_6` FOREIGN KEY (`article_group_id`) REFERENCES `article_group` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `section`
--

LOCK TABLES `section` WRITE;
/*!40000 ALTER TABLE `section` DISABLE KEYS */;
INSERT INTO `section` VALUES (1,'home','home',0,NULL,NULL,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
/*!40000 ALTER TABLE `section` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `section_document`
--

DROP TABLE IF EXISTS `section_document`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `section_document` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `section_id` int(11) NOT NULL,
  `document_id` int(11) NOT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `unique_section_document` (`section_id`,`document_id`),
  KEY `section_document_FI_2` (`document_id`),
  CONSTRAINT `section_document_FK_1` FOREIGN KEY (`section_id`) REFERENCES `section` (`id`) ON DELETE CASCADE,
  CONSTRAINT `section_document_FK_2` FOREIGN KEY (`document_id`) REFERENCES `document` (`id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `section_document`
--

LOCK TABLES `section_document` WRITE;
/*!40000 ALTER TABLE `section_document` DISABLE KEYS */;
/*!40000 ALTER TABLE `section_document` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `section_link`
--

DROP TABLE IF EXISTS `section_link`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `section_link` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `section_id` int(11) NOT NULL,
  `link_id` int(11) NOT NULL,
  `target_blank` int(11) DEFAULT '1',
  PRIMARY KEY (`id`),
  UNIQUE KEY `unique_section_link` (`section_id`,`link_id`),
  KEY `section_link_FI_2` (`link_id`),
  CONSTRAINT `section_link_FK_1` FOREIGN KEY (`section_id`) REFERENCES `section` (`id`) ON DELETE CASCADE,
  CONSTRAINT `section_link_FK_2` FOREIGN KEY (`link_id`) REFERENCES `link` (`id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `section_link`
--

LOCK TABLES `section_link` WRITE;
/*!40000 ALTER TABLE `section_link` DISABLE KEYS */;
/*!40000 ALTER TABLE `section_link` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `section_tag`
--

DROP TABLE IF EXISTS `section_tag`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `section_tag` (
  `section_id` int(11) DEFAULT NULL,
  `tag_id` int(11) DEFAULT NULL,
  `id` int(11) NOT NULL AUTO_INCREMENT,
  PRIMARY KEY (`id`),
  KEY `section_tag_FI_1` (`section_id`),
  KEY `section_tag_FI_2` (`tag_id`),
  CONSTRAINT `section_tag_FK_1` FOREIGN KEY (`section_id`) REFERENCES `section` (`id`) ON DELETE CASCADE,
  CONSTRAINT `section_tag_FK_2` FOREIGN KEY (`tag_id`) REFERENCES `tag` (`id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `section_tag`
--

LOCK TABLES `section_tag` WRITE;
/*!40000 ALTER TABLE `section_tag` DISABLE KEYS */;
/*!40000 ALTER TABLE `section_tag` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sf_guard_group`
--

DROP TABLE IF EXISTS `sf_guard_group`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `sf_guard_group` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) NOT NULL,
  `description` text,
  PRIMARY KEY (`id`),
  UNIQUE KEY `sf_guard_group_name_unique` (`name`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sf_guard_group`
--

LOCK TABLES `sf_guard_group` WRITE;
/*!40000 ALTER TABLE `sf_guard_group` DISABLE KEYS */;
/*!40000 ALTER TABLE `sf_guard_group` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sf_guard_group_permission`
--

DROP TABLE IF EXISTS `sf_guard_group_permission`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `sf_guard_group_permission` (
  `group_id` int(11) NOT NULL,
  `permission_id` int(11) NOT NULL,
  PRIMARY KEY (`group_id`,`permission_id`),
  KEY `sf_guard_group_permission_FI_2` (`permission_id`),
  CONSTRAINT `sf_guard_group_permission_FK_1` FOREIGN KEY (`group_id`) REFERENCES `sf_guard_group` (`id`) ON DELETE CASCADE,
  CONSTRAINT `sf_guard_group_permission_FK_2` FOREIGN KEY (`permission_id`) REFERENCES `sf_guard_permission` (`id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sf_guard_group_permission`
--

LOCK TABLES `sf_guard_group_permission` WRITE;
/*!40000 ALTER TABLE `sf_guard_group_permission` DISABLE KEYS */;
/*!40000 ALTER TABLE `sf_guard_group_permission` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sf_guard_login_failure`
--

DROP TABLE IF EXISTS `sf_guard_login_failure`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `sf_guard_login_failure` (
  `username` varchar(128) NOT NULL,
  `ip_address` varchar(255) NOT NULL,
  `cookie_id` text,
  `at` datetime NOT NULL,
  `id` int(11) NOT NULL AUTO_INCREMENT,
  PRIMARY KEY (`id`),
  KEY `username_index` (`username`),
  KEY `ip_index` (`ip_address`),
  KEY `at_index` (`at`)
) ENGINE=InnoDB AUTO_INCREMENT=16 DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sf_guard_login_failure`
--

LOCK TABLES `sf_guard_login_failure` WRITE;
/*!40000 ALTER TABLE `sf_guard_login_failure` DISABLE KEYS */;
INSERT INTO `sf_guard_login_failure` VALUES ('admin','163.10.10.114','choiqueCMS-froNt3nD-default=fakbg9dbtkbtpp38nbje2dc057; choiqueCMS-local=s677ngsotug6849255olqgcgb7','2013-08-14 20:28:51',1),('admin','163.10.10.114','choiqueCMS-froNt3nD-default=fakbg9dbtkbtpp38nbje2dc057; choiqueCMS-local=s677ngsotug6849255olqgcgb7','2013-08-14 20:28:57',2),('root','163.10.10.114','choiqueCMS-froNt3nD-default=fakbg9dbtkbtpp38nbje2dc057; choiqueCMS-local=s677ngsotug6849255olqgcgb7','2013-08-14 20:29:03',3),('admin','163.10.10.114','choiqueCMS-froNt3nD-default=fakbg9dbtkbtpp38nbje2dc057; choiqueCMS-local=s677ngsotug6849255olqgcgb7','2013-08-14 20:29:08',4),('admin','163.10.10.114','choiqueCMS-froNt3nD-default=fakbg9dbtkbtpp38nbje2dc057; choiqueCMS-local=s677ngsotug6849255olqgcgb7','2013-08-14 20:30:17',5),('root','163.10.10.114','choiqueCMS-froNt3nD-default=fakbg9dbtkbtpp38nbje2dc057; choiqueCMS-local=s677ngsotug6849255olqgcgb7','2013-08-14 20:39:56',6),('admin','163.10.10.114','choiqueCMS-froNt3nD-default=fakbg9dbtkbtpp38nbje2dc057; choiqueCMS-local=s677ngsotug6849255olqgcgb7','2013-08-14 20:40:03',7),('admin','163.10.10.114','choiqueCMS-froNt3nD-default=fakbg9dbtkbtpp38nbje2dc057; choiqueCMS-local=s677ngsotug6849255olqgcgb7','2013-08-14 20:44:12',8),('admin','163.10.10.114','choiqueCMS-froNt3nD-default=fakbg9dbtkbtpp38nbje2dc057; choiqueCMS-local=s677ngsotug6849255olqgcgb7','2013-08-14 20:44:21',9),('admin','163.10.10.114','choiqueCMS-froNt3nD-default=fakbg9dbtkbtpp38nbje2dc057; choiqueCMS-local=s677ngsotug6849255olqgcgb7','2013-08-14 20:47:30',10),('admin','163.10.10.114','choiqueCMS-froNt3nD-default=fakbg9dbtkbtpp38nbje2dc057; choiqueCMS-local=s677ngsotug6849255olqgcgb7','2013-08-14 20:47:34',11),('admin','163.10.10.114','choiqueCMS-froNt3nD-default=fakbg9dbtkbtpp38nbje2dc057; choiqueCMS-local=s677ngsotug6849255olqgcgb7','2013-08-14 20:47:42',12),('admin','163.10.10.90','choiqueCMS-local=nc7bn297dhj3glij3564srobg6','2013-08-14 21:00:57',13),('admin','163.10.10.114','choiqueCMS-local=nbnmkqa50qt2ei7ug62tl85qn7','2013-08-15 17:59:42',14),('admin','163.10.10.114','choiqueCMS-local=nbnmkqa50qt2ei7ug62tl85qn7','2013-08-15 17:59:46',15);
/*!40000 ALTER TABLE `sf_guard_login_failure` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sf_guard_permission`
--

DROP TABLE IF EXISTS `sf_guard_permission`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `sf_guard_permission` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) NOT NULL,
  `section` int(11) NOT NULL DEFAULT '0',
  `description` text,
  PRIMARY KEY (`id`),
  UNIQUE KEY `sf_guard_permission_name_unique` (`name`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sf_guard_permission`
--

LOCK TABLES `sf_guard_permission` WRITE;
/*!40000 ALTER TABLE `sf_guard_permission` DISABLE KEYS */;
/*!40000 ALTER TABLE `sf_guard_permission` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sf_guard_remember_key`
--

DROP TABLE IF EXISTS `sf_guard_remember_key`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `sf_guard_remember_key` (
  `user_id` int(11) NOT NULL,
  `remember_key` varchar(32) DEFAULT NULL,
  `ip_address` varchar(15) NOT NULL,
  `created_at` datetime DEFAULT NULL,
  PRIMARY KEY (`user_id`,`ip_address`),
  CONSTRAINT `sf_guard_remember_key_FK_1` FOREIGN KEY (`user_id`) REFERENCES `sf_guard_user` (`id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sf_guard_remember_key`
--

LOCK TABLES `sf_guard_remember_key` WRITE;
/*!40000 ALTER TABLE `sf_guard_remember_key` DISABLE KEYS */;
/*!40000 ALTER TABLE `sf_guard_remember_key` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sf_guard_user`
--

DROP TABLE IF EXISTS `sf_guard_user`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `sf_guard_user` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(128) DEFAULT NULL,
  `email` varchar(128) DEFAULT NULL,
  `username` varchar(128) NOT NULL,
  `algorithm` varchar(128) NOT NULL DEFAULT 'sha1',
  `salt` varchar(128) NOT NULL,
  `password` varchar(128) NOT NULL,
  `created_at` datetime DEFAULT NULL,
  `last_login` datetime DEFAULT NULL,
  `is_active` int(11) NOT NULL DEFAULT '1',
  `is_super_admin` int(11) NOT NULL DEFAULT '0',
  `change_password_at` datetime DEFAULT NULL,
  `must_change_password` int(11) NOT NULL DEFAULT '0',
  `section_id` int(11) DEFAULT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `sf_guard_user_username_unique` (`username`),
  KEY `sf_guard_user_FI_1` (`section_id`),
  CONSTRAINT `sf_guard_user_FK_1` FOREIGN KEY (`section_id`) REFERENCES `section` (`id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sf_guard_user`
--

LOCK TABLES `sf_guard_user` WRITE;
/*!40000 ALTER TABLE `sf_guard_user` DISABLE KEYS */;
/*!40000 ALTER TABLE `sf_guard_user` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sf_guard_user_group`
--

DROP TABLE IF EXISTS `sf_guard_user_group`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `sf_guard_user_group` (
  `user_id` int(11) NOT NULL,
  `group_id` int(11) NOT NULL,
  PRIMARY KEY (`user_id`,`group_id`),
  KEY `sf_guard_user_group_FI_2` (`group_id`),
  CONSTRAINT `sf_guard_user_group_FK_1` FOREIGN KEY (`user_id`) REFERENCES `sf_guard_user` (`id`) ON DELETE CASCADE,
  CONSTRAINT `sf_guard_user_group_FK_2` FOREIGN KEY (`group_id`) REFERENCES `sf_guard_group` (`id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sf_guard_user_group`
--

LOCK TABLES `sf_guard_user_group` WRITE;
/*!40000 ALTER TABLE `sf_guard_user_group` DISABLE KEYS */;
/*!40000 ALTER TABLE `sf_guard_user_group` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sf_guard_user_permission`
--

DROP TABLE IF EXISTS `sf_guard_user_permission`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `sf_guard_user_permission` (
  `user_id` int(11) NOT NULL,
  `permission_id` int(11) NOT NULL,
  PRIMARY KEY (`user_id`,`permission_id`),
  KEY `sf_guard_user_permission_FI_2` (`permission_id`),
  CONSTRAINT `sf_guard_user_permission_FK_1` FOREIGN KEY (`user_id`) REFERENCES `sf_guard_user` (`id`) ON DELETE CASCADE,
  CONSTRAINT `sf_guard_user_permission_FK_2` FOREIGN KEY (`permission_id`) REFERENCES `sf_guard_permission` (`id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sf_guard_user_permission`
--

LOCK TABLES `sf_guard_user_permission` WRITE;
/*!40000 ALTER TABLE `sf_guard_user_permission` DISABLE KEYS */;
/*!40000 ALTER TABLE `sf_guard_user_permission` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `shortcut`
--

DROP TABLE IF EXISTS `shortcut`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `shortcut` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `multimedia_id` int(11) DEFAULT NULL,
  `container_slotlet_id` int(11) DEFAULT NULL,
  `title` varchar(256) NOT NULL,
  `body` text,
  `reference` varchar(256) NOT NULL,
  `reference_type` tinyint(4) DEFAULT '0',
  `open_in_new_window` int(11) DEFAULT '0',
  `priority` int(11) DEFAULT '0',
  `comment` text,
  `is_published` int(11) DEFAULT '0',
  `created_by` int(11) DEFAULT NULL,
  `created_at` datetime DEFAULT NULL,
  `updated_by` int(11) DEFAULT NULL,
  `updated_at` datetime DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `shortcut_FI_1` (`multimedia_id`),
  KEY `shortcut_FI_2` (`container_slotlet_id`),
  KEY `shortcut_FI_3` (`created_by`),
  KEY `shortcut_FI_4` (`updated_by`),
  CONSTRAINT `shortcut_FK_1` FOREIGN KEY (`multimedia_id`) REFERENCES `multimedia` (`id`),
  CONSTRAINT `shortcut_FK_2` FOREIGN KEY (`container_slotlet_id`) REFERENCES `container_slotlet` (`id`) ON DELETE SET NULL,
  CONSTRAINT `shortcut_FK_3` FOREIGN KEY (`created_by`) REFERENCES `sf_guard_user` (`id`),
  CONSTRAINT `shortcut_FK_4` FOREIGN KEY (`updated_by`) REFERENCES `sf_guard_user` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `shortcut`
--

LOCK TABLES `shortcut` WRITE;
/*!40000 ALTER TABLE `shortcut` DISABLE KEYS */;
/*!40000 ALTER TABLE `shortcut` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `slotlet`
--

DROP TABLE IF EXISTS `slotlet`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `slotlet` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(256) NOT NULL,
  `cls` varchar(256) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `slotlet`
--

LOCK TABLES `slotlet` WRITE;
/*!40000 ALTER TABLE `slotlet` DISABLE KEYS */;
/*!40000 ALTER TABLE `slotlet` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `source`
--

DROP TABLE IF EXISTS `source`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `source` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(256) NOT NULL,
  `description` text,
  `comment` text,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `source`
--

LOCK TABLES `source` WRITE;
/*!40000 ALTER TABLE `source` DISABLE KEYS */;
/*!40000 ALTER TABLE `source` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `tag`
--

DROP TABLE IF EXISTS `tag`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `tag` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(256) NOT NULL,
  `description` text,
  `comment` text,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `tag`
--

LOCK TABLES `tag` WRITE;
/*!40000 ALTER TABLE `tag` DISABLE KEYS */;
/*!40000 ALTER TABLE `tag` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `template`
--

DROP TABLE IF EXISTS `template`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `template` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(256) NOT NULL,
  `public_name` varchar(255) DEFAULT NULL,
  `comment` text,
  `created_at` datetime DEFAULT NULL,
  `updated_at` datetime DEFAULT NULL,
  `created_by` int(11) DEFAULT NULL,
  `updated_by` int(11) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `template_FI_1` (`created_by`),
  KEY `template_FI_2` (`updated_by`),
  CONSTRAINT `template_FK_1` FOREIGN KEY (`created_by`) REFERENCES `sf_guard_user` (`id`),
  CONSTRAINT `template_FK_2` FOREIGN KEY (`updated_by`) REFERENCES `sf_guard_user` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `template`
--

LOCK TABLES `template` WRITE;
/*!40000 ALTER TABLE `template` DISABLE KEYS */;
/*!40000 ALTER TABLE `template` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `temporary_layout`
--

DROP TABLE IF EXISTS `temporary_layout`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `temporary_layout` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `layout` text,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `temporary_layout`
--

LOCK TABLES `temporary_layout` WRITE;
/*!40000 ALTER TABLE `temporary_layout` DISABLE KEYS */;
/*!40000 ALTER TABLE `temporary_layout` ENABLE KEYS */;
UNLOCK TABLES;
/*!40103 SET TIME_ZONE=@OLD_TIME_ZONE */;

/*!40101 SET SQL_MODE=@OLD_SQL_MODE */;
/*!40014 SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS */;
/*!40014 SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS */;
/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
/*!40111 SET SQL_NOTES=@OLD_SQL_NOTES */;

-- Dump completed on 2013-08-15 20:15:41
